// Applies a focus style to an mat-button element for each of the supported palettes.
@mixin _mat-button-focus-overlay-color($config-or-theme) {
    $config: mat-get-color-config($config-or-theme);
    $primary: map-get($config, primary);
    $accent: map-get($config, accent);
    $warn: map-get($config, warn);
    $caution: map-get($config, caution);
    $success: map-get($config, success);
    $highlight: map-get($config, highlight);

    &.mat-primary .mat-button-focus-overlay {
        background-color: mat-color($primary);
    }

    &.mat-accent .mat-button-focus-overlay {
        background-color: mat-color($accent);
    }

    &.mat-warn .mat-button-focus-overlay {
        background-color: mat-color($warn);
    }

    &.mat-caution .mat-button-focus-overlay {
        background-color: mat-color($caution);
    }

    &.mat-success .mat-button-focus-overlay {
        background-color: mat-color($success);
    }

    &.mat-highlight .mat-button-focus-overlay {
        background-color: mat-color($highlight);
    }

    &.mat-button-disabled .mat-button-focus-overlay {
        background-color: transparent;
    }
}

@mixin _mat-button-ripple-color($theme, $hue, $opacity: $_mat-button-ripple-opacity) {
    $primary: map-get($theme, primary);
    $accent: map-get($theme, accent);
    $warn: map-get($theme, warn);
    $caution: map-get($theme, caution);
    $success: map-get($theme, success);
    $highlight: map-get($theme, highlight);

    &.mat-primary .mat-ripple-element {
        @include _mat-button-ripple-background($primary, $hue, $opacity);
    }

    &.mat-accent .mat-ripple-element {
        @include _mat-button-ripple-background($accent, $hue, $opacity);
    }

    &.mat-warn .mat-ripple-element {
        @include _mat-button-ripple-background($warn, $hue, $opacity);
    }

    &.mat-caution .mat-ripple-element {
        @include _mat-button-ripple-background($caution, $hue, $opacity);
    }

    &.mat-success .mat-ripple-element {
        @include _mat-button-ripple-background($success, $hue, $opacity);
    }

    &.mat-highlight .mat-ripple-element {
        @include _mat-button-ripple-background($highlight, $hue, $opacity);
    }
}

// Applies a property to an mat-button element for each of the supported palettes.
@mixin _mat-button-theme-property($theme, $property, $hue) {
    $primary: map-get($theme, primary);
    $accent: map-get($theme, accent);
    $warn: map-get($theme, warn);
    $caution: map-get($theme, caution);
    $success: map-get($theme, success);
    $highlight: map-get($theme, highlight);
    $background: map-get($theme, background);
    $foreground: map-get($theme, foreground);

    &.mat-primary {
        #{$property}: mat-color($primary, $hue);
    }
    &.mat-accent {
        #{$property}: mat-color($accent, $hue);
    }
    &.mat-warn {
        #{$property}: mat-color($warn, $hue);
    }
    &.mat-caution {
        #{$property}: mat-color($caution, $hue);
    }
    &.mat-success {
        #{$property}: mat-color($success, $hue);
    }
    &.mat-highlight {
        #{$property}: mat-color($highlight, $hue);
    }

    &.mat-primary,
    &.mat-accent,
    &.mat-warn,
    &.mat-caution,
    &.mat-success,
    &.mat-highlight,
    &.mat-button-disabled {
        &.mat-button-disabled {
            $palette: if($property == "color", $foreground, $background);
            #{$property}: mat-color($palette, disabled-button);
        }
    }
}

@mixin mat-icon-color($config-or-theme) {
    $config: mat-get-color-config($config-or-theme);
    $primary: map-get($config, primary);
    $accent: map-get($config, accent);
    $warn: map-get($config, warn);
    $caution: map-get($config, caution);
    $success: map-get($config, success);
    $highlight: map-get($config, highlight);
    $background: map-get($config, background);
    $foreground: map-get($config, foreground);

    .mat-icon {
        &.mat-primary {
            color: mat-color($primary, text);
        }

        &.mat-accent {
            color: mat-color($accent, text);
        }

        &.mat-warn {
            color: mat-color($warn, text);
        }
        &.mat-caution {
            color: mat-color($caution, text);
        }
        &.mat-success {
            color: mat-color($success, text);
        }
        &.mat-highlight {
            color: mat-color($highlight, text);
        }
    }
}
